Package org.jfree.layouting.input.style

## Class CSSDeclarationRule

- java.lang.Object
- - org.jfree.layouting.input.style.StyleRule
  - - org.jfree.layouting.input.style.CSSDeclarationRule

- Direct Known Subclasses:
    `CSSCounterRule`, `CSSFontFaceRule`, `CSSMediaRule`, `CSSPageAreaRule`, `CSSPageRule`, `CSSStringRule`, `CSSStyleRule`

      public abstract class CSSDeclarationRule
      extends StyleRule

  This class is a merger between the CSSStyleDeclaration and the other stylerule classes holding property name pairs. Actually, this is what once was called a stylesheet in JFreeReport.

  StyleProperties are key as Strings and have CSSValues as mapped values..
  Author:
    Thomas Morgner
  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `CSSDeclarationRule​(StyleSheet parentStyle, StyleRule parentRule)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `clear​()` |
    `java.lang.Object` | `clone​()` |
    `boolean[]` | `getImportantValues​()` |
    `CSSValue` | `getPropertyCSSValue​(StyleKey propertyName)` |
    `StyleKey[]` | `getPropertyKeysAsArray​()` |
    `CSSValue[]` | `getStyleValues​()` |
    `boolean` | `isEmpty​()` |
    `boolean` | `isImportant​(StyleKey propertyName)` |
    `void` | `removeProperty​(StyleKey name)` |
    `void` | `setImportant​(StyleKey propertyName, boolean important)` |
    `void` | `setPropertyValue​(StyleKey propertyName, CSSValue value)` |
    `void` | `setPropertyValue​(StyleKey propertyName, CSSValue value, boolean important)` |
    `void` | `setPropertyValueAsString​(java.lang.String styleKey, java.lang.String value)` |
    `void` | `setPropertyValueAsString​(StyleKey styleKey, java.lang.String value)` | Parses the given value for the stylekey.

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from class org.jfree.layouting.input.style.StyleRule

      `getParentRule, getParentStyle, getStyleKeyRegistry, isReadOnly, makeReadOnly, setParentRule, setParentStyle`

- - ### Constructor Detail

    - #### CSSDeclarationRule

          protected CSSDeclarationRule​(StyleSheet parentStyle,
                                       StyleRule parentRule)

  - ### Method Detail

    - #### isImportant

          public boolean isImportant​(StyleKey propertyName)

    - #### setImportant

          public void setImportant​(StyleKey propertyName,
                                   boolean important)

    - #### getPropertyCSSValue

          public CSSValue getPropertyCSSValue​(StyleKey propertyName)

    - #### setPropertyValueAsString

          public void setPropertyValueAsString​(java.lang.String styleKey,
                                               java.lang.String value)

    - #### setPropertyValueAsString

          public void setPropertyValueAsString​(StyleKey styleKey,
                                               java.lang.String value)

      Parses the given value for the stylekey. As stylekeys are only defined for atomic style declarations, this method will only affect a single name-value pair.
      Parameters:
        `styleKey` -
        `value` -

    - #### setPropertyValue

          public void setPropertyValue​(StyleKey propertyName,
                                       CSSValue value)

    - #### setPropertyValue

          public void setPropertyValue​(StyleKey propertyName,
                                       CSSValue value,
                                       boolean important)

    - #### removeProperty

          public void removeProperty​(StyleKey name)

    - #### clear

          public void clear​()

    - #### getPropertyKeysAsArray

          public StyleKey[] getPropertyKeysAsArray​()

    - #### getStyleValues

          public CSSValue[] getStyleValues​()

    - #### getImportantValues

          public boolean[] getImportantValues​()

    - #### clone

          public java.lang.Object clone​()
                                 throws java.lang.CloneNotSupportedException

      Overrides:
        `clone` in class `StyleRule`
      Throws:
        `java.lang.CloneNotSupportedException`

    - #### isEmpty

          public boolean isEmpty​()